' 25.09.2009 by Ms
' Mit Atmega 8 L ein Siemens Handy S45
' direkt anzusteuern ohne Pegelwandler.
' Beim einschalten wird Led Gelb eingeschaltet dann wird
' Zuerst eine Pause von 1. Minute eingelegt  bevor Programm anluft, weil
' Betriebsspannung zu niedrig ist und sonst Fehlalarm ausgelt wird, wenn Led
' Gelb anfngt zu blinken ist die Schaltung scharf.
' Wenn am Pir Sensor eine Bewegung erkannt wird blinkt einmal kurz die grne
' Led in der Mitte der Platine auf und signalisiert das Pir-Sensor eine Bewegung
' erkannt hat ,die Rote Led blitzt kurz auf und zeigt an
' Das eine Meldung ans Handy geschickt wird, die gelbe Led bleibt ca 1 Minute
' an ( in dieser Zeit ist die Anlage nicht aktiv) in dieser Zeitspanne
' wird kein weiterer Alarm an das Handy gesendet.
' Wenn die Sabotageschleife unterbrochen wird blitzt kurz die Rot Led und
' Signalisiert dem Handy das er eine SMS versenden soll, die gelbe hrt auf zu
' blinken , damit ist die Anlage inaktiv, erst wenn die Schleife wieder
' geschlossen wird , wird nach 1 Minute die Anlage wieder aktiv
' genauso verhlt es sich mit dem Alarmkontakt, nur das in diesem Fall
' eine andere SMS gesendet wird.
' Um die Anlage auszuschalten gengt ein kurzer Anruf 017650524289, die Blaue
' Led blinkt kurz auf eine sms wird zurckgesendet und die Anlage schaltet ab.

' Led Gelb  an Pind. 2  fr Betriebskontrolle zeigt an das der Prozessor luft !
' Led Rot an Pind.1 ( TXD) Sendeanzeige des UART ,sendet zum Handy
' Led Grn an Pind.0 (RXD) Empfangsanzeige des UART,empfngt vom Handy
' Led Blau an PortB.0 Anzeige fr eingehenden Anruf
' PIR-Sensor Led Grn an PinD.7  Anzeige fr Bewegung im Raum.

'
'------------------------------------------------------------------------------
$regfile "m8def.dat"          'Definiert den Atmega als Atmega 8
$baud = 19200
$crystal = 1000000
Ddrd = &B00000100             ' Port D.2  als Ausgang setzen alle a. als Eingang
Ddrb = &B01000001             ' Port B.0 und B.6 Als Ausgang setzen
Portd = &B00011000            ' Pull Up setzen fr pin D3 und D4
Dim Inaktiv As Byte           '
Dim Anrufzeit As Byte
'------------------Variable um Anrufe zu empfangen_____________________________
  Dim Empfang As String * 1
'____________________Hier  E i n s t e l l en  _______________________________
Inaktiv = 60                  ' Zeitvorgabe die zwischen ersten und nchsten Alarm
                              ' mindestens vergehen muss in Sekunden um die
                              ' Anlage wieder zu aktivieren
'______________________________________________________________________________
Anrufzeit = 10                ' Zeitvorgabe nach wie viele Sekunden soll nach
                              ' Alarmauslsung
                              ' wieder aufgelegt werden
'__________________________________________________________________________
Portb.6 = 1                   ' Led Grn  aus
Wait 60                       ' Pause , weil Sensor nach einschalten der Spannung
' innerhalb von 20 Sekunden ein Signal abgibt

Do                            ' Anfang Programmschleife
'------------------------------------------------------------------------------
Toggle Portd.2                'Led gelb Betriebsanzeige  Zustand wechseln

'-------------- Abfrage ob Pir Sensor Bewegung meldet -------------------------
If Pind.7 = 1 Then Waitms 20  ' PIR Eingang abfragen
If Pind.7 = 1 Then            ' Ist Signal vorhanden dann
Portb.6 = 0                   ' Led grn einschalten
Waitms 50                     ' Led grn 200msekunden anlassen
Portb.6 = 1                   ' dann Led grn ausschalten

If Pind.7 = 1 Then Gosub Bewegung_erkannt       ' Zur unterroutine springen
Else                          ' sonst
Portb.6 = 1                   ' Led grn ausschalten
 End If
'------------------------------------------------------------------------------
'                Abfrage ob Sabotageschleife geffnet wurde

If Pind.3 = 1 Then Waitms 20  'Tastenprellen verhindern
If Pind.3 = 1 Then Gosub Sabotage       ' Wenn ffner geffnet wird dann gib Alarm
'------------------------------------------------------------------------------
'               Abfrage Ob Alarm Ausgeloesst Wurde

'Portd.2 = 1                             ' Led gelb aus
If Pind.4 = 0 Then Waitms 20  'Tastenprellen verhindern
If Pind.4 = 0 Then Gosub Alarm_ausgeloest       ' Wenn Schlieer zu ist dann gib Alarm
  Waitms 300                  ' Pause von 500 Millisekunden
'Portd.2 = 0                             ' Led Gelb als Betriebsanzeige An
  Waitms 300

'________________________________________________________________________________
'
' Empngt Serielle Schnittstelle igend was anderes als Askii Zeichen Null dann
' schaltet Blaue Led ein
'
Empfang = Inkey()
If Empfang <> Chr(0) Then
Portb.0 = 1
If Portb.0 = 1 Then Gosub Anlage_aus


Else
Portb.0 = 0
Wait 1                        ' Pause von 1. Sekunde
End If

  Loop
  End
'______________________________________________________________________________
'                    Alarm Geben ( Nur Anruf ) bei Bewegung erfasst !
'______________________________________________________________________________
Bewegung_erkannt:

Print "ATDP+4915772738947;"   ' Nummer whlen
Wait Anrufzeit                ' Pause von n Sekunden
Print "AT+CHUP"               ' Hrer auflegen
Wait Inaktiv

Return
'______________________________________________________________________________
'                          Alarm geben bei Sabotage ! ( SMS versenden )
'______________________________________________________________________________
Sabotage:
Waitms 500                    'Pause on 500 ms
Print "At+cmss=1"             ' 6te SMS versenden
Wait Inaktiv
'Pause Zwischen Zwei Alarmeldungen Damit
' nicht zuviele SMS verschickt werden
Return
'______________________________________________________________________________
'                                Alarm ausgeloest !
'______________________________________________________________________________
Alarm_ausgeloest:
Waitms 500                    'Pause on 500 ms
Print "At+cmss=2"             ' 2te SMS versenden
Wait Inaktiv
' Pause zwischen zwei Alarmeldungen damit
' nicht zuviele SMS verschickt werden
'______________________________________________________________________________
Return

'______________________________________________________________________________
'                              Anlage ausschalten !
'______________________________________________________________________________
Anlage_aus:
Waitms 500
Print "at+cmss=3"             ' 3 te SMS versenden
Portb.0 = 0                   ' Blaue Led ausschaltn
End









